﻿using System;
using System.IO;
using System.Text;
using System.Windows;
using System.Net;
using System.Threading;
using System.Web;
using System.Drawing;
using System.Windows.Media.Imaging;
using System.Configuration;

namespace Micro.Listener
{
    /// <summary>
    /// 异步处理
    /// 调用示例：
    /// 一、启动服务：new Micro.Listener.ListenerSync(8181).Start();
    /// 二、资源调用：
    /// 1、HTML：webBrower.Source = new Uri("http://localhost:8080/res/template.html");
    /// 2、CSS/JS：<link href="http://localhost:8080/res/style.css" rel="stylesheet" />
    /// 3、图片：<img src="http://localhost:8080/res/logo.png"/>  
    /// </summary>
    public class ListenerAsync
    {
        public int listenport { set; get; }
        public ListenerAsync()
        {
            this.listenport = 8080;
        }
        public ListenerAsync(int _listenport)
        {
            this.listenport = _listenport;
        }
        HttpListener listener;
        /// <summary>
        /// 构造简HTTP服务器
        /// </summary>
        public void Start(bool IsAsync = false)
        {
            if (listener == null)
            {
                listener = new HttpListener();
                listener.AuthenticationSchemes = AuthenticationSchemes.Anonymous;
                listener.Prefixes.Add(String.Format("http://localhost:{0}/", this.listenport));
                listener.Start();
                listener.BeginGetContext(new AsyncCallback(AsyncResult), null);
            }
        }
        ListenerRequest RequestHelper;
        ListenerResponse ResponseHelper;
        /// <summary>
        /// 接收请求
        /// </summary>
        void AsyncResult(IAsyncResult ar)
        {
            var context = listener.EndGetContext(ar);
            if (!ListenerUtils.IsUriResource(context.Request.RawUrl))
            {
                HttpListenerRequest request = context.Request;
                HttpListenerResponse response = context.Response;
                RequestHelper = new ListenerRequest(request);
                ResponseHelper = new ListenerResponse(response);
                RequestHelper.DispatchResources(fs =>
                {
                    ResponseHelper.WriteToClient(fs);// 对相应的请求做出回应
                });
            }
            //接收下一个请求
            listener.BeginGetContext(new AsyncCallback(AsyncResult), null);
        }
    }
}
