﻿using System;
using System.IO;
using System.Text;
using System.Windows;
using System.Net;
using System.Threading;

namespace Micro.Listener
{
    public class ListenerRequest
    {
        private HttpListenerRequest request;
        public ListenerRequest(HttpListenerRequest request)
        {
            this.request = request;
        }
        public Stream RequestStream { get; set; }
        public void ExtracHeader()
        {
            RequestStream = request.InputStream;
        }

        public delegate void ExecutingDispatch(FileStream fs);
        public void DispatchResources(ExecutingDispatch action)
        {
            string rawUrl = request.RawUrl.TrimStart('/');
            string ContentType, FileType = ListenerUtils.GetFileType(rawUrl, out ContentType);
            string filePath = string.Format(@"{0}/{1}", Environment.CurrentDirectory, rawUrl);       
            filePath = filePath.Replace("/", "\\");
            if (File.Exists(filePath))
            {
                FileStream fs = new FileStream(filePath, FileMode.Open, FileAccess.ReadWrite);
                if (action != null) action.Invoke(fs);
            }
        }
    }
}
