﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace Micro.Listener
{
    public class ListenerUtils
    {
        /// <summary>
        /// 取得文件类型
        /// </summary>
        /// <param name="rawUrl"></param>
        /// <returns></returns>
        public static string GetFileType(string rawUrl, out string ContentType)
        {
            rawUrl = rawUrl.ToLower();
            if (rawUrl.Contains("."))
            {
                string extension = rawUrl.Substring(rawUrl.LastIndexOf("."));
                switch (extension)
                {
                    case ".htm":
                        ContentType = "text/htm;charset=utf-8";
                        return "text";
                    case ".html":
                        ContentType = "text/html;charset=utf-8";
                        return "text";
                    case ".css":
                        ContentType = "text/css;charset=utf-8";
                        return "text";
                    case ".js":
                        ContentType = "text/javascript;charset=utf-8";
                        return "text";
                    case ".json":
                        ContentType = "text/json;charset=utf-8";
                        return "text";
                    case ".xml":
                        ContentType = "text/xml;charset=utf-8";
                        return "text";
                    case ".txt":
                        ContentType = "text/plain;charset=utf-8";
                        return "text";
                    case ".jpeg":
                        ContentType = "image/jpeg";
                        return "image";
                    case ".jpg":
                        ContentType = "image/jpg";
                        return "image";
                    case ".gif":
                        ContentType = "image/gif";
                        return "image";
                    case ".png":
                        ContentType = "image/png";
                        return "image";
                    default:
                        ContentType = "text/html";
                        return "text";
                }
            }
            ContentType = "";
            return ContentType;
        }
        /// <summary>
        /// 是否为资源调用
        /// </summary>
        /// <param name="uri">资源路径</param>
        /// <returns>bool</returns>
        public static bool IsUriResource(string uri)
        {
            if (uri.Contains("pack://application") || uri.Contains(";component"))
            {
                return true;
            }
            return false;
        }
    }
}
